<?php

declare(strict_types=1);

namespace Dedi\SyliusMegamenuPlugin\Entity;

use Dedi\SyliusMegamenuPlugin\Enum\EntryTypes;
use Sylius\Component\Resource\Model\TranslationInterface;

class DirectLinkEntry extends Entry implements DirectLinkEntryInterface
{
    /** @var bool */
    protected $opensInNewTab = false;

    public function opensInNewTab(): bool
    {
        return $this->opensInNewTab;
    }

    public function setOpensInNewTab(bool $opensInNewTab): DirectLinkEntryInterface
    {
        $this->opensInNewTab = $opensInNewTab;

        return $this;
    }

    public function getType(): string
    {
        return EntryTypes::DIRECT_LINK;
    }

    protected function createTranslation(): TranslationInterface
    {
        return new DirectLinkEntryTranslation();
    }

    public function getUrl(): ?string
    {
        return $this->getTranslation()->getUrl();
    }

    public function setUrl(?string $url): DirectLinkEntryInterface
    {
        $this->getTranslation()->setUrl($url);

        return $this;
    }

    public function getLabel(): ?string
    {
        return $this->getTranslation()->getLabel();
    }

    public function setLabel(?string $label): DirectLinkEntryInterface
    {
        $this->getTranslation()->setLabel($label);

        return $this;
    }
}
